Index: trunk/src/VBox/Main/HostUSBDeviceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/HostUSBDeviceImpl.cpp	(revision 31891)
+++ trunk/src/VBox/Main/HostUSBDeviceImpl.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/RemoteUSBBackend.cpp
===================================================================
--- trunk/src/VBox/Main/RemoteUSBBackend.cpp	(revision 31891)
+++ trunk/src/VBox/Main/RemoteUSBBackend.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/USBDeviceFilterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/USBDeviceFilterImpl.cpp	(revision 31891)
+++ trunk/src/VBox/Main/USBDeviceFilterImpl.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/USBProxyService.cpp
===================================================================
--- trunk/src/VBox/Main/USBProxyService.cpp	(revision 31891)
+++ trunk/src/VBox/Main/USBProxyService.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/darwin/USBProxyServiceDarwin.cpp
===================================================================
--- trunk/src/VBox/Main/darwin/USBProxyServiceDarwin.cpp	(revision 31891)
+++ trunk/src/VBox/Main/darwin/USBProxyServiceDarwin.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/freebsd/USBProxyServiceFreeBSD.cpp
===================================================================
--- trunk/src/VBox/Main/freebsd/USBProxyServiceFreeBSD.cpp	(revision 31891)
+++ trunk/src/VBox/Main/freebsd/USBProxyServiceFreeBSD.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/include/HostUSBDeviceImpl.h
===================================================================
--- trunk/src/VBox/Main/include/HostUSBDeviceImpl.h	(revision 31891)
+++ trunk/src/VBox/Main/include/HostUSBDeviceImpl.h	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/include/USBDeviceFilterImpl.h
===================================================================
--- trunk/src/VBox/Main/include/USBDeviceFilterImpl.h	(revision 31891)
+++ trunk/src/VBox/Main/include/USBDeviceFilterImpl.h	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2009 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/include/USBProxyService.h
===================================================================
--- trunk/src/VBox/Main/include/USBProxyService.h	(revision 31891)
+++ trunk/src/VBox/Main/include/USBProxyService.h	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/linux/USBProxyServiceLinux.cpp
===================================================================
--- trunk/src/VBox/Main/linux/USBProxyServiceLinux.cpp	(revision 31891)
+++ trunk/src/VBox/Main/linux/USBProxyServiceLinux.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/os2/USBProxyServiceOs2.cpp
===================================================================
--- trunk/src/VBox/Main/os2/USBProxyServiceOs2.cpp	(revision 31891)
+++ trunk/src/VBox/Main/os2/USBProxyServiceOs2.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/solaris/USBProxyServiceSolaris.cpp
===================================================================
--- trunk/src/VBox/Main/solaris/USBProxyServiceSolaris.cpp	(revision 31891)
+++ trunk/src/VBox/Main/solaris/USBProxyServiceSolaris.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2007 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 
Index: trunk/src/VBox/Main/win/USBProxyServiceWindows.cpp
===================================================================
--- trunk/src/VBox/Main/win/USBProxyServiceWindows.cpp	(revision 31891)
+++ trunk/src/VBox/Main/win/USBProxyServiceWindows.cpp	(revision 31892)
@@ -7,6 +7,11 @@
  * Copyright (C) 2006-2010 Oracle Corporation
  *
- * Oracle Corporation confidential
- * All rights reserved
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
 