Index: trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc
===================================================================
--- trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/Support/win/VBoxDrv.rc	(revision 32375)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2009 Oracle Corporation
+ * Copyright (C) 2006-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -49,5 +49,5 @@
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxDrv.sys\0"
-         VALUE "ProductName",      "Sun VirtualBox\0"
+         VALUE "ProductName",      VBOX_PRODUCT "\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/VBoxNetFlt-win.rc	(revision 32375)
@@ -1,4 +1,9 @@
+/* $Id$ */
+/** @file
+ * VBoxNetFlt - Resource file containing version info and icon.
+ */
+
 /*
- * Copyright (C) 2009 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -43,5 +48,5 @@
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", FILENAME_STR
-         VALUE "ProductName",      "Sun VirtualBox\0"
+         VALUE "ProductName",      VBOX_PRODUCT "\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/HostDrivers/VBoxNetFlt/win/notifyobj/VBoxNetFltNotify.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxNetFlt/win/notifyobj/VBoxNetFltNotify.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/VBoxNetFlt/win/notifyobj/VBoxNetFltNotify.rc	(revision 32375)
@@ -1,4 +1,9 @@
+/* $Id$ */
+/** @file
+ * VBoxNetFltNotify - Resource file containing version info and icon.
+ */
+
 /*
- * Copyright (C) 2009 Oracle Corporation
+ * Copyright (C) 2009-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -10,4 +15,5 @@
  * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
  */
+
 #include <windows.h>
 #include <VBox/version.h>
@@ -44,5 +50,5 @@
     VALUE "LegalCopyright",  VBOX_RC_LEGAL_COPYRIGHT
     VALUE "OriginalFilename","VBoxNetFltNotify.dll\0"
-    VALUE "ProductName",     "Sun VirtualBox\0"
+    VALUE "ProductName",     VBOX_PRODUCT "\0"
     VALUE "ProductVersion",  VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
     END
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/vboxusb.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/vboxusb.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Device/vboxusb.rc	(revision 32375)
@@ -1,8 +1,9 @@
+/* $Id$ */
+/** @file
+ * VBoxUSB - Resource file containing version info and icon.
+ */
+
 /*
- * VBox host drivers - USB drivers - Win32 USB device
- *
- * Resource definitions
- *
- * Copyright (C) 2006-2009 Oracle Corporation
+ * Copyright (C) 2006-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -39,5 +40,5 @@
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxUSB.sys\0"
-         VALUE "ProductName",      "Sun VirtualBox\0"
+         VALUE "ProductName",      VBOX_PRODUCT "\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/USBFilter.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/USBFilter.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Filter/USBFilter.rc	(revision 32375)
@@ -1,8 +1,9 @@
+/* $Id$ */
+/** @file
+ * VBoxUSBFilter - Resource file containing version info and icon.
+ */
+
 /*
- * VBox host drivers - USB drivers - Win32 USB filter driver
- *
- * Resource definitions
- *
- * Copyright (C) 2006-2009 Oracle Corporation
+ * Copyright (C) 2006-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -39,5 +40,5 @@
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxUSBFlt.sys\0"
-         VALUE "ProductName",      "Sun VirtualBox\0"
+         VALUE "ProductName",      VBOX_PRODUCT "\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END
Index: trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/USBMon.rc
===================================================================
--- trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/USBMon.rc	(revision 32358)
+++ trunk/src/VBox/HostDrivers/VBoxUSB/win/Monitor/USBMon.rc	(revision 32375)
@@ -1,8 +1,9 @@
+/* $Id$ */
+/** @file
+ * VBoxUSBMon - Resource file containing version info and icon.
+ */
+
 /*
- * VBox host drivers - USB drivers - Win32 USB monitor driver
- *
- * Resource definitions
- *
- * Copyright (C) 2006-2009 Oracle Corporation
+ * Copyright (C) 2006-2010 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -39,5 +40,5 @@
          VALUE "LegalCopyright",   VBOX_RC_LEGAL_COPYRIGHT
          VALUE "OriginalFilename", "VBoxUSBMon.sys\0"
-         VALUE "ProductName",      "Sun VirtualBox\0"
+         VALUE "ProductName",      VBOX_PRODUCT "\0"
          VALUE "ProductVersion",   VBOX_VERSION_MAJOR "." VBOX_VERSION_MINOR "." VBOX_VERSION_BUILD ".r" VBOX_SVN_REV "\0"
       END