Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxMisc/efi-app/Readme.txt
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxMisc/efi-app/Readme.txt	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxMisc/efi-app/Readme.txt	(revision 32394)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,17 +14,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 Here could be some help how to manage files on efi-app ISO
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxOSELogo/VBoxOSELogo.inf
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxOSELogo/VBoxOSELogo.inf	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxOSELogo/VBoxOSELogo.inf	(revision 32394)
@@ -6,7 +6,5 @@
 
 #
-# Copyright (C) 2009.2010 Sun Microsystems, Inc.
-#
-# Copyright (C)  Oracle Corporation
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dec
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dec	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dec	(revision 32394)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,17 +14,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dsc
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dsc	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.dsc	(revision 32394)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,17 +14,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.fdf
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.fdf	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkg.fdf	(revision 32394)
@@ -6,5 +6,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -15,17 +15,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.dsc
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.dsc	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.dsc	(revision 32394)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -14,17 +14,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.fdf
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.fdf	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSE.fdf	(revision 32394)
@@ -6,5 +6,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -21,11 +21,4 @@
 # VirtualBox OSE distribution, in which case the provisions of the
 # CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSEX64.dsc
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSEX64.dsc	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgOSEX64.dsc	(revision 32394)
@@ -11,17 +11,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 
Index: trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgX64.dsc
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgX64.dsc	(revision 32130)
+++ trunk/src/VBox/Devices/EFI/Firmware2/VBoxPkg/VBoxPkgX64.dsc	(revision 32394)
@@ -2,5 +2,5 @@
 
 #
-# Copyright (C) 2009-2010 Sun Microsystems, Inc.
+# Copyright (C) 2009-2010 Oracle Corporation
 #
 # This file is part of VirtualBox Open Source Edition (OSE), as
@@ -11,17 +11,4 @@
 # VirtualBox OSE distribution. VirtualBox OSE is distributed in the
 # hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# The contents of this file may alternatively be used under the terms
-# of the Common Development and Distribution License Version 1.0
-# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
-# VirtualBox OSE distribution, in which case the provisions of the
-# CDDL are applicable instead of those of the GPL.
-#
-# You may elect to license modified versions of this file under the
-# terms and conditions of either the GPL or the CDDL or both.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
 #/
 